SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #FinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!FinderTests methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 19:00'!
test01lookForMissingImplementorsShouldFailIfClassCantUnderstandIt
	self should: [AbstractTestClass1 lookForMissingImplementors: #methodNotUnderstood]
		raise: Error
		withExceptionDo: [ :anError | anError description = 'Error: El metodo no pertenece a la clase']! !

!FinderTests methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 19:00'!
test02shouldReturnNoClassesIfSuperClassDontHaveSubclasses
	| missingImplementors |
	missingImplementors := AbstractTestClass2 lookForMissingImplementors: #abstractMethod.
	self assert: missingImplementors size = 0.! !

!FinderTests methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 6/24/2013 17:49'!
test03shouldReturnConcreteSubclassesIfThereIsNoImplementationOfAbstractMethod
	| missingImplementors |
	missingImplementors := AbstractTestClass13 lookForMissingImplementors: #abstractMethod.
	self assert: (missingImplementors includes: ConcreteTestClass131).
	self assert: missingImplementors size = 1.! !

!Behavior methodsFor: '*Metaprogramacion' stamp: 'JuanManuelTastzian 6/24/2013 00:58'!
leafSubClasses
	^self allSubclasses select: [ :aSubClass | aSubClass subclasses isEmpty].! !

!Behavior methodsFor: '*Metaprogramacion' stamp: 'JuanManuelTastzian 6/24/2013 17:48'!
lookForMissingImplementors: aMessage 
	| missingImplementors leafSubClasses |
"Ver implementacin de classAndMethodFor: que se encuentra aqu en Behavior. El bloque de codigo toma una class y un compiledMethod al que le podemos preguntar si es abstracto"
	missingImplementors := Set new.
	leafSubClasses :=  self leafSubClasses.
	(self methodDictionary includesKey: aMessage)
	ifTrue: [ leafSubClasses
		do:	[ :leafSubclass | leafSubclass classAndMethodFor: aMessage
			do:	[ :implementingClass :compiledMethod | compiledMethod isAbstract 
				ifTrue: [ missingImplementors add: leafSubclass ]
				]
				ifAbsent: [ ^nil ] 
			  ].
	]
	ifFalse: [ self error: 'El metodo no pertenece a la clase' ].

	^ missingImplementors! !

Object subclass: #AbstractTestClass1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass1 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:37'!
abstractMethod
	^self subclassResponsibility ! !

AbstractTestClass1 subclass: #AbstractTestClass12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass12 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:18'!
abstractMethod
	^self subclassResponsibility ! !

AbstractTestClass12 subclass: #ConcreteTestClass121
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteTestClass121 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:24'!
abstractMethod
	^nil! !

AbstractTestClass1 subclass: #AbstractTestClass13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass13 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:38'!
abstractMethod
	^self subclassResponsibility ! !

AbstractTestClass13 subclass: #ConcreteTestClass131
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractTestClass13 subclass: #ConcreteTestClass132
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteTestClass132 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 19:11'!
abstractMethod
	^nil! !

Object subclass: #AbstractTestClass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractTestClass2 methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/23/2013 18:39'!
abstractMethod
	^self subclassResponsibility ! !
